/*
 *  <Short Description>
 *  Copyright (C) 2023  Brett Terpstra
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BLT_WITH_GRAPHICS_TEXTURE_MANAGER_H
#define BLT_WITH_GRAPHICS_TEXTURE_MANAGER_H

#include <blt/std/hashmap.h>
#include <blt/gfx/texture.h>
#include <blt/std/thread.h>
#include <string>

namespace blt::gfx
{
    
    struct loadable_texture
    {
        std::string path;
        std::string name;
    };
    
    class texture_resource_manager
    {
        private:
            blt::thread_pool<false> pool;
            std::vector<loadable_texture> textures_to_load;
            HASHMAP<std::string, texture_gl2D*> textures_2d;
        public:
            texture_resource_manager() = default;
            ~texture_resource_manager();
    };
    
}

#endif //BLT_WITH_GRAPHICS_TEXTURE_MANAGER_H
